> For the complete documentation index, see [llms.txt](https://docs.caf.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.caf.io/caf-sdk/android/standalone-modules/faceauthenticator.md).

# Face Authenticator (DEPRECATED)

{% hint style="warning" %}
This SDK has been discontinued, instead of using it please use the CafSDK with the CafFaceLiveness module with the parameter `executeFaceAuth = true` in the configuration object `CafFaceLivenessConfig`.
{% endhint %}

## FaceAuthenticator

### Current Version

| Name                | Version |
| ------------------- | ------- |
| `FaceAuthenticator` | 5.5.0   |

### Requirements

* Minimum Android SDK API version: `minSdk 26` (Android 8 Oreo)
* Android SDK API version to compile: `compileSdk 34`

To publish your app on the *Google Play Store*, you must complete a data safety form. Since we integrate with the *FingerPrintJS SDK*, you'll need to provide the following information:

| Question in Google Play Console's data safety form                  | Response                                    |
| ------------------------------------------------------------------- | ------------------------------------------- |
| Does your app collect or share any of the required user data types? | Yes.                                        |
| What type of data is collected?                                     | Device or other identifiers.                |
| Is this data collected, shared, or both?                            | Collected.                                  |
| Is this data processed ephemerally?                                 | Yes.                                        |
| Why is this user data collected?                                    | Fraud Prevention, Security, and Compliance. |

{% hint style="warning" %}
`versionName` and `versionCode` are mandatory for the SDK to work correctly.
{% endhint %}

### SDK Dependencies

FaceAuthenticator leverages the following external SDKs:

| SDK            | Version |
| -------------- | ------- |
| `FaceLiveness` | 5.2.0   |

* [FaceLiveness Android](https://github.com/combateafraude/public-docs/blob/docs-sdks/android/getting-started/faceliveness.md): Enables the integration of live facial verification and fingerprint authentication technology.

#### Transitive dependencies

| SDK                         | Version |
| --------------------------- | ------- |
| `iProov Biometrics Android` | 11.1.0  |
| `Fingerprint Pro Android`   | 2.7.0   |

* [iProov Biometrics Android](https://github.com/iProov/android): Enables the integration of live facial verification technology.
* [Fingerprint Pro Android](https://github.com/fingerprintjs/fingerprintjs-pro-android-demo): Provides fingerprint authentication capabilities to enhance security features in your app.

These dependencies are easily managed through Gradle and are bundled with the SDK for ease of installation.

#### Runtime permissions

| Permission | Reason                                                         | Required |
| ---------- | -------------------------------------------------------------- | -------- |
| `CAMERA`   | Capturing the selfie in policies with facial re-authentication | Yes      |

#### Installation

If your version of Gradle is earlier than 7, add these lines to your `build.gradle`.

```groovy
allprojects {
  repositories {
  ...
  maven { url 'https://repo.combateafraude.com/android/release' }
  maven { url 'https://raw.githubusercontent.com/iProov/android/patch912/maven/' }
  maven { url 'https://maven.fpregistry.io/releases' }
  maven { url 'https://jitpack.io' }

}}
```

If your version of Gradle is 7 or newer, add these lines to your `settings.gradle`.

```groovy
dependencyResolutionManagement {
    repositories {
        ...
        maven { url 'https://repo.combateafraude.com/android/release' }
        maven { url 'https://raw.githubusercontent.com/iProov/android/patch912/maven/' }
        maven { url 'https://maven.fpregistry.io/releases' }
        maven { url 'https://jitpack.io' }
    }
}
```

Add support for Java 8 to your `build.gradle` file. Skip this if Java 8 is enabled.

```groovy
android {
    ...
    compileOptions {
        sourceCompatibility JavaVersion.VERSION_1_8
        targetCompatibility JavaVersion.VERSION_1_8
    }
}
```

Add the SDK version to the dependencies section in your `build.gradle` file

```groovy
dependencies {
    implementation 'io.caf.sdk:new-face-authenticator:{version}'
}
```

### Instantiating the SDK

First, create an object of type `FaceAuthenticator`. This object is for you to configure all your business rules:

```java
FaceAuthenticator faceAuthenticator = new FaceAuthenticator.Builder(String mobileToken)
    //see table below
    .build();
```

#### Builder method

| Parameter                                                                                                                                                                                                                                                                                                                             | Required                           |
| ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------- |
| <p><code>String mobileToken</code></p><p>Usage token associated with your Identity account (see how to get it <a href="https://github.com/combateafraude/public-docs/blob/docs-sdks/sdk_integration_documentation.md#2-generating-access-tokens">here</a>).</p>                                                                       | Yes                                |
| <p><code>.setStage(CAFStage stage)</code></p><p>Used to redirect the SDK to the desired stage in caf api. The method takes as parameter an enum <code>CafStage</code> to select the environment:</p><ul><li><code>CAFStage.PROD</code> set production environment.</li><li><code>CAFStage.BETA</code> set beta environment.</li></ul> | No. The default is `CAFStage.PROD` |
| <p><code>.setFilter(Filter filter)</code></p><p>Used to change the SDK filter, that has the following options:</p><ul><li><code>Filter.NATURAL</code></li><li><code>Filter.LINE\_DRAWING</code></li></ul>                                                                                                                             | No, the default is `LINE_DRAWING`  |
| <p><code>.setEnableScreenshots(boolean bool)</code></p><p>Used to enable screenshots during the SDK scan. Disabled by default for security reasons.</p>                                                                                                                                                                               | No, the default is `false`         |
| <p><code>.setLoadingScreen(boolean bool)</code></p><p>Used to enable a default loading progressbar during loading events. You can set your customized loading screen instead, using the <code>onLoading</code> method below.</p>                                                                                                      | No, the default is `false`         |
| <p><code>.setImageUrlExpirationTime(Time time)</code></p><p>Used to customize the image URL expiration time, that has the following options:</p><ul><li><code>Time.THREE\_HOURS</code></li><li><code>Time.THIRTY\_DAYS</code></li></ul>                                                                                               | No, the default is `null`          |

### Consulting a policy

To authenticate a user, use the `authenticate()` method. You must enter the user's CPF, your app's Context and a `VerifyAuthenticationListener` object.

#### Parameters

| Parameter                                                                         | Required |
| --------------------------------------------------------------------------------- | -------- |
| <p><code>String personId</code></p><p>User CPF</p>                                | Yes      |
| <p><code>Context context</code></p><p>Your app Context</p>                        | Yes      |
| <p><code>VerifyAuthenticationListener listener</code></p><p>Response Listener</p> | Yes      |

#### Example

```java
faceAuthenticator.authenticate(Context context, String personId, new VerifyAuthenticationListener() {
    @Override
    public void onSuccess(FaceAuthenticatorResult result) {
        
    }

    @Override
    public void onError(FaceAuthenticatorErrorResult errorResult) {
        
    }

    @Override
    public void onCancel() {
        
    }

    @Override
    public void onLoading() {
        
    }

    @Override
    public void onLoaded() {
        
    }
});
```

#### VerifyAuthenticationListener options

| Method      | Description                                                                                                                           |
| ----------- | ------------------------------------------------------------------------------------------------------------------------------------- |
| `onSuccess` | The execution has ended with success, you have to use the `result` and check for the results of the SDK.                              |
| `onError`   | The execution has ended with error, you have to use the `result` and check for the error results of the SDK.                          |
| `onCancel`  | The execution has been cancelled by the user.                                                                                         |
| `onLoading` | The SDK is loading, you can use this method to set a action in your app, for example a loading.                                       |
| `onLoaded`  | The SDK is not loading anymore, you can use this method to set a action in your app, for example, you can stop your previous loading. |

### FaceAuthenticatorResult

#### Success

| Return                  | Reason                                                                                                                                                                                                                                                                                                                  |
| ----------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `String signedResponse` | Signed response from the CAF server confirming that the captured selfie has a real face. This parameter is used to get an extra layer of security, checking that the signature of the response is not broken, or caused by request interception. If it is broken, there is a strong indication of request interception. |

**Signedresponse params**

| Event        | Description                                                                            |
| ------------ | -------------------------------------------------------------------------------------- |
| `requestId`  | Request identifier.                                                                    |
| `isAlive`    | Validation of a living person, identifies whether the user passed successfully or not. |
| `isMatch`    | Face match validation result.                                                          |
| `token`      | Request token.                                                                         |
| `userId`     | User identifier provided for the request.                                              |
| `imageUrl`   | Temporary link to the image, generated by our API.                                     |
| `personId`   | User identifier provided for the SDK.                                                  |
| `sdkVersion` | Sdk version in use.                                                                    |
| `iat`        | Token expiration.                                                                      |
| `message`    | Return message.                                                                        |

{% hint style="warning" %}
The **isAlive** parameter is **VERY IMPORTANT**, based on this validation, the user can be guided to continue the flow or not. In case of `isAlive: true`, it would be able to continue with the journey. If `isAlive: false`, this user is not valid and should be prevented from continuing their journey. Furthermore, the **isMatch** parameter indicates whether the Face Match passed successfully or not, returning `isMatch: true` in case of success and `false` in case of failure.
{% endhint %}

#### FaceAuthenticationErrorResult

| Return                | Reason                        |
| --------------------- | ----------------------------- |
| `String description`  | Error description.            |
| `ErrorType errorType` | Return the type of the error. |

**ErrorType**

| type                 | Description                                                                                                                                                                                                                                                       |
| -------------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `CAMERA_PERMISSION`  | <p>Indicates that the device does not have permission to access the camera.<br>This error typically occurs when the user denies access to the camera or if the app lacks the necessary permissions.</p>                                                           |
| `NETWORK_EXCEPTION`  | <p>Indicates a network-related error occurred.<br>This error may occur due to various network issues such as a lack of internet connection, server timeouts, or network congestion.</p>                                                                           |
| `SERVER_EXCEPTION`   | Indicates an exception occurred on the server-side.\<br. />This error is typically returned when there is an issue with the server processing the facial recognition request. This could include server-side errors, misconfigurations, or service interruptions. |
| `TOKEN_EXCEPTION`    | <p>Indicates an issue with the provided token.<br>This error may occur if the provided authentication token is invalid, expired, or lacks the necessary permissions to perform facial recognition tasks.</p>                                                      |
| `UNSUPPORTED_DEVICE` | <p>Indicates that the device is not supported.<br>This error may occur if the device hardware or software does not meet the minimum requirements for facial recognition functionality.</p>                                                                        |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.caf.io/caf-sdk/android/standalone-modules/faceauthenticator.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
